import es
buildinglib = __import__("sentrysounds.buildinglib")
from buildinglib import Building

class Sentry(Building):
    def __init__(self, index):
        Building.__init__(self, index)
        self.state = self.getState()
        self.level = self.getLevel()
        self.kills = self.getKills()
    def refreshData(self, data):
        events = []
        constructed = data["CObjectSentrygun.baseclass.m_flPercentageConstructed"]
        if (constructed==1.0) != self.buildstate:
            event = {}
            event['name'] = "sentry_constructed"
            event['index'] = self.index
            events.append(event)
        self.buildstate = (constructed==1.0)
        #kills
        didkill = False
        killcount = int(data["CObjectSentrygun.SentrygunLocalData.m_iKills"])
        if killcount > self.kills:
            didkill = True
            event = {}
            event['name'] = "sentry_player_killed"
            event['index'] = self.index
            event['kills'] = killcount
            events.append(event)
        self.kills = killcount
        #health
        self.health = int(data["CObjectSentrygun.baseclass.m_iHealth"])
        #attacking
        state = int(data["CObjectSentrygun.m_iState"])
        if self.state < 2 and state == 2:
            event = {}
            event['name'] = "sentry_attacking"
            event['index'] = self.index
            events.append(event)
        if self.state == 2 and state < 2 and not didkill:
            event = {}
            event['name'] = "sentry_stopped_attacking"
            event['index'] = self.index
            events.append(event)
        self.state = state
        #sapper
        sappy = bool(data["CObjectSentrygun.baseclass.m_bHasSapper"])
        if sappy and not self.sapped:
            event = {}
            event['name'] = "sentry_sapped"
            event['index'] = self.index
            events.append(event)
        elif self.sapped and not sappy:
            event = {}
            event['name'] = "sentry_unsapped"
            event['index'] = self.index
            events.append(event)
        self.sapped = sappy
        # upgraded?
        level = int(data["CObjectSentrygun.m_iUpgradeLevel"])
        if level != self.level:
            event = {}
            event['name'] = "sentry_upgraded"
            event['index'] = self.index
            event['level'] = level
            events.append(event)
        self.level = level
        return events
    def getState(self):
        return int(es.getindexprop(self.index, "CObjectSentrygun.m_iState"))
    def getKills(self):
        return int(es.getindexprop(self.index, "CObjectSentrygun.SentrygunLocalData.m_iKills"))
    def getLevel(self):
        return int(es.getindexprop(self.index, "CObjectSentrygun.m_iUpgradeLevel"))
        
class SentryManager(object):
    def __init__(self):
        self.sentries = {}
    def getSentry(self, index):
        if self.sentries.has_key(index):
            return self.sentries[index]
        else:
            newbie = Sentry(index)
            self.sentries[index] = newbie
            return newbie
    def sentryDied(self, index):
        if self.sentries.has_key(index):
            del self.sentries[index]
    def checkSentries(self):
        events = []
        sentrydata = es.createentitylist("obj_sentrygun")
        for i in self.sentries.keys():
            #es.dbgmsg(0, "checkSentries2", i, type(i))
            p = 1
            index = self.sentries[i].index
            if not sentrydata.has_key(index):
                event = {}
                event['name'] = "sentry_down"
                event['index'] = index
                event['ownerid'] = self.sentries[i].ownerid
                events.append(event)
                self.sentryDied(index)
        for i in sentrydata.keys():
            sentry_events = self.getSentry(i).refreshData(sentrydata[i])
            events += sentry_events
        return events
                
            
