# Sentry Sounds
# By Mattie Casper
# Feel free to use any of the code in here for whatever you may want.
# It's not particularly good code. Eventually might consider using
#  sentrylib as something 
import es
import sentrysounds
import gamethread
import random
sentrylib = __import__("sentrysounds.sentrylib")
from sentrylib import SentryManager

info = es.AddonInfo() 
info.name     = "Mattie's Sentry Sounds" 
info.version  = "0.6" 
info.url      = "http://addons.eventscripts.com/addons/view/sentrysounds" 
info.basename = "sentrysounds" 
info.author   = "Mattie"

sentrysounds_ver = es.ServerVar("sentrysounds_ver", info.version, "Version of Mattie's SentrySounds addon")

sounds = {}
# you can add and adjust sounds below.
sounds["sentry_player_killed"]      = ['sentry/gotcha_portal.mp3',
                                       'sentry/goodbye_portal.mp3',
                                       'sentry/haveaniceday_portal.mp3',
                                       'sentry/illmissyou_portal.mp3',
                                       'sentry/comeagainsoon_portal.mp3']
sounds["sentry_constructed"]        = ['sentry/sentrymodeactivated_portal.mp3',
                                       'sentry/deploying_portal.mp3',
                                       'sentry/atyourservice_portal.mp3']
sounds["sentry_attacking"]          = ['sentry/thereyouare_portal.mp3',
                                       'sentry/hello_portal.mp3',
                                       'sentry/targetacquired_portal.mp3',
                                       'sentry/hithere_portal.mp3']
sounds["sentry_stopped_attacking"]  = ['sentry/isanyonethere_portal.mp3',
                                       'sentry/areyoustillthere_portal.mp3',
                                       'sentry/couldyoucomeoverhere_portal.mp3',
                                       'sentry/searching_portal.mp3',
                                       'sentry/targetlost_portal.mp3',
                                       'sentry/canihelpyou_portal.mp3',
                                       'sentry/haveapresent_portal.mp3']
sounds["sentry_sapped"]             = ['sentry/criticalerror_portal.mp3',
                                       'sentry/nohardfeelings_portal.mp3',
                                       'sentry/help_portal.mp3',
                                       'sentry/malfunctioning_portal.mp3',
                                       'sentry/shuttingdown_portal.mp3',
                                       'sentry/somethingiswrong_portal.mp3',
                                       'sentry/uhoh_portal.mp3',
                                       'sentry/ifeelfaint_portal.mp3',
                                       'sentry/theresaspy_portal.mp3',
                                       'sentry/nostopsappingme_portal.mp3']
sounds["sentry_unsapped"]           = ['sentry/sentrymodeactivated_portal.mp3',
                                       'sentry/backinbusiness_portal.mp3',
                                       'sentry/thatwasclose_portal.mp3']
sounds["sentry_upgraded_3"]         = ['sentry/itsrockettime_portal.mp3',
                                       'sentry/upgrading_portal.mp3',
                                       'sentry/missilesengaged_portal.mp3']
sounds["sentry_upgraded_2"]         = ['sentry/standback_portal.mp3',
                                       'sentry/upgrading_portal.mp3',
                                       'sentry/atyourservice_portal.mp3']


# sound properties, defaults
attentuation =  es.ServerVar("sentrysounds_attenuation",    0.50, "Change fade distance for sentry sounds")
volume =        es.ServerVar("sentrysounds_volume",         0.65, "Change overall volume for sentry sounds")
pitch =         es.ServerVar("sentrysounds_pitch",        110.00, "Change overall pitch for sentry sounds")
flags =         es.ServerVar("sentrysounds_soundflags",     3.00, "Controls what sound flags to use for sentry sounds (advanced)") # allow volume (1) and pitch changes (2)

#global sentry manager reference
senmgr = None

# The function to add each song in the list to the downloadables stringtable
def addSoundDownloads():
    for soundEvent in sounds.keys():
        for soundname in sounds[soundEvent]:
            es.stringtable('downloadables', 'sound/' + soundname)
 
   
def load():
    global senmgr
    senmgr = SentryManager()
    es.addons.registerTickListener(ticker)
    sentrysounds_ver.makepublic()
    addSoundDownloads()
    
def unload():
    es.addons.unregisterTickListener(ticker)

def es_map_start(e):
    global senmgr
    if senmgr:
        del senmgr
    senmgr = SentryManager()
    addSoundDownloads()

def teamplay_round_start(e):
    global senmgr
    if senmgr:
        del senmgr
    senmgr = SentryManager()

def _randomSentrySound(index, eventname):
    es.emitsound('entity', index, random.choice(sounds[eventname]), float(volume), float(attentuation), int(flags), int(pitch))
    
def ticker():
    try:
        global senmgr
        if senmgr is None:
            senmgr = SentryManager()
        events = senmgr.checkSentries()
        if events:
            for p in events:
                if p['name'] == "sentry_down":
                    # cancel all the sounds as best as we can
                    gamethread.cancelDelayed("sentry_peace_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_kill_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_sapped_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_unsapped_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_upgraded_%d" %p['index'])                    
                if p['name'] == "sentry_constructed":
                    gamethread.delayedname(0.5, "sentry_constructed_%d" %p['index'], _randomSentrySound, (p['index'], p['name']))
                if p['name'] == "sentry_attacking":
                    # cancel pending sounds so we have less overlap
                    gamethread.cancelDelayed("sentry_peace_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_constructed_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_unsapped_%d" %p['index'])                    
                    gamethread.cancelDelayed("sentry_upgraded_%d" %p['index'])                    
                    es.emitsound('entity', p['index'], random.choice(sounds[p['name']]), volume, attentuation)
                if p['name'] == "sentry_stopped_attacking":
                    gamethread.delayedname(2, "sentry_peace_%d" %p['index'], _randomSentrySound, (p['index'], p['name']))
                if p['name'] == "sentry_player_killed":
                    # stop the peace sound in a momeny after the player is dead.
                    gamethread.delayed(1, gamethread.cancelDelayed, ("sentry_peace_%d" %p['index']))
                    gamethread.cancelDelayed("sentry_peace_%d" %p['index'])
                    gamethread.delayedname(1, "sentry_kill_%d" %p['index'], _randomSentrySound, (p['index'], p['name']))
                if p['name'] == "sentry_sapped":
                    # stop other sentry sounds since this sentry is dying                    
                    gamethread.cancelDelayed("sentry_peace_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_kill_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_unsapped_%d" %p['index'])
                    gamethread.cancelDelayed("sentry_upgraded_%d" %p['index'])                    
                    gamethread.delayedname(2, "sentry_sapped_%d" %p['index'], _randomSentrySound, (p['index'], p['name']))      
                if p['name'] == "sentry_unsapped":
                    # stop the sapped sound to avoid issues with repeated saps/repairs
                    gamethread.cancelDelayed("sentry_sapped_%d" %p['index'])
                    gamethread.delayedname(1.4, "sentry_unsapped_%d" %p['index'], _randomSentrySound, (p['index'], p['name']))
                if p['name'] == "sentry_upgraded":
                    gamethread.delayedname(1.1, "sentry_upgraded_%d" %p['index'], _randomSentrySound, (p['index'], p['name']+'_'+str(p['level'])))

    except Exception, e:
        es.dbgmsg(0, "SentrySounds Exception:", str(e), "\nUnloading tick listener.")
        es.addons.unregisterTickListener(ticker)
    
